// stdafx.cpp : source file that includes just the standard includes
// ConsoleApplication2.pch will be the pre-compiled header
// stdafx.obj will contain the pre-compiled type information
#include "stdafx.h"
// TODO: reference any additional headers you need in STDAFX.H
// and not in this file
	ChildList::ChildList(){
		start=NULL;
		end=NULL;
		num=0;
	}
	void ChildList::add(GeoObj* value){
		struct ChildNode* newnode=new ChildNode;
		newnode->value=value;
		if (this->num==0){
			this->start=newnode;
			this->end=newnode;
			newnode->next=NULL;
		}
		else{
			this->end->next=newnode;
			newnode->next=NULL;
			newnode->pre=this->end;
			this->end=newnode;
		}
		this->num+=1;
	}
	void ChildList::del(GeoObj* node){
		ChildNode* PNodeToDel=find(node);
		if (PNodeToDel==NULL){
			return;
		}
		else{
			if (this->num==1){
				delete this->start;
				this->start=NULL;
				this->end=NULL;
			}
			else{
				this->end->pre->next=NULL;
				ChildNode* cur=this->end;
				this->end=this->end->pre;
				delete cur;
			}
			this->num-=1;
		}
	}
	ChildNode* ChildList::find(GeoObj* node){
		ChildNode* current;
		current=this->start;
		while (current!=NULL){
			if (current->value==node){
				return current;
			}
			current=current->next;
		}
		return NULL;
	}
	ChildList::~ChildList(){
		ChildNode* current=this->start;
		while (current!=NULL){
			ChildNode* temp=current->next;
			delete current;
			current=temp;
		}
	}
	List::List(){
		this->start=NULL;
		this->end=NULL;
		this->num=0;
	}
	void List::add(GeoObj* GeoObj){
		Node* N=new Node;
		N->value=GeoObj;
		N->next=NULL;
		if (num==0){
			this->num++;
			this->start=end=N;
		}
		else{
			this->num++;
			this->end->next=N;
			this->end=N;
		}
	}
	void List::del(GeoObj* Obj){
		Node* current=this->start,*pre=NULL;		
		while (current!=NULL){
			if (current->value==Obj){
				if (pre==NULL){
					this->start=current->next;
					delete current;
				}
				else{
					pre->next=current->next;
					delete current;
				}
				this->num--;
				return;
			}
		}
	}
	Sketch::Sketch(){
		eleList=new List;
	}
	void GeoObj::unlock(){
		if (this->parentnum==0){
			return;
		}
		if (this->parentnum%2==1){
			this->parent[0]->children->del(this);
			this->parent[0]=NULL;
		}
		if (this->parentnum>=2){
			this->parent[1]->children->del(this);
			this->parent[1]=NULL;
		}
		this->determine_type=FREE;
	}
	GeoObj::GeoObj(string name,bool isvisible){
		this->name=name;
		this->visible=isvisible;
		this->color=0x000000;
		this->parentnum=0;
		this->parent[0]=NULL;
		this->parent[1]=NULL;
		this->visited=false;
		this->children=new ChildList;
		this->sketch=_sketch;
		this->determine_type=FREE;
		this->sketch->eleList->add(this);
	}
	GeoObj::~GeoObj(){
		if (this->parent[0]!=NULL){
			this->parent[0]->children->del(this);
		}
		if (this->parent[1]!=NULL){
			this->parent[1]->children->del(this);
		}
		delete this->children;
		sketch->eleList->del(this);
	}
	bool GeoObj::setvisible(bool visible){
		return this->visible=visible;
	}
	Point::Point():GeoObj(){
		this->X=NONEXIST;
		this->Y=NONEXIST;
		this->type=GPOINT;
	}
	double Point::dist(Point* point1, Point* point2){
		return sqrt((point1->X-point2->X)*(point1->X-point2->X)+(point1->Y-point2->Y)*(point1->Y-point2->Y));
	}
	Point* Point::intersect(GeoObj* GeoObj1,GeoObj* GeoObj2,bool isnear){		
		if (GeoObj1->type==GPOINT || GeoObj2->type==GPOINT||GeoObj1->sketch!=GeoObj2->sketch) return NULL;
		Sketch* sketch=GeoObj1->sketch;
		if (GeoObj1->type==GCIRCLE || GeoObj2->type==GCIRCLE){
			Point* interpoint=new Point;
			if (isnear){
				interpoint->parent[0]=GeoObj1;
				interpoint->parent[1]=GeoObj2;
				interpoint->determine_type=CIR_NEAR;
				GeoObj1->children->add(interpoint);
				GeoObj2->children->add(interpoint);
				interpoint->update();
			}
			else{
				interpoint->parent[0]=GeoObj1;
				interpoint->parent[1]=GeoObj2;
				interpoint->determine_type=CIR_FAR;
				GeoObj1->children->add(interpoint);
				GeoObj2->children->add(interpoint);
				interpoint->update();
			}
			return interpoint;
		}
		else{
			Point* interpoint=new Point;
			interpoint->parent[0]=GeoObj1;
			interpoint->parent[1]=GeoObj2;
			GeoObj1->children->add(interpoint);
			GeoObj2->children->add(interpoint);
			interpoint->determine_type=LIN;
			interpoint->update();
			return interpoint;
		}
	}
	bool Point::hasnon(void){
		if (this->X==NONEXIST||this->Y==NONEXIST){
			return true;
		}
		return false;
	}
	bool Point::update(void){
		if (this->determine_type==FREE){
			ChildNode* current=this->children->start;
			while (current!=NULL){
				current->value->update();
				current=current->next;
			}
			return false;
		}
		else{
			double* result=GeoObj::intercept(this->parent[0],this->parent[1]);
			if (this->determine_type==CIR_FAR){				
				this->X=result[2];
				this->Y=result[3];
			}
			else if (this->determine_type==CIR_NEAR){
				this->X=result[0];
				this->Y=result[1];
			}
			else if (this->determine_type==LIN){
				this->X=result[0];
				this->Y=result[1];
			}
		}
		ChildNode* current=this->children->start;
		while (current!=NULL){
			current->value->update();
			current=current->next;
		}
		return true;
	}
	bool Point::setXY(double X,double Y){
		if(this->determine_type==FREE){
			this->X=X;
			this->Y=Y;
			this->update();
			return true;
		}
		else{
			return false;
		}
	}
	double Point::getX(){
		return this->X;
	}
	double Point::getY(){
		return this->Y;
	}

	void Point::paint(){
		if (this->visible && !this->hasnon()){
			fprintf(_resultfile,"Point %f %f %s\n",this->X,this->Y,this->name.c_str());
			printf("Point:(%f,%f),%s\n",this->X,this->Y,this->name.c_str());
		}
	}
	Line::Line():GeoObj(){
		this->X1=NONEXIST;
		this->X2=NONEXIST;
		this->Y1=NONEXIST;
		this->Y2=NONEXIST;
		this->line_type=line_type;
		this->type=GLINE;
	}
	bool Line::update(void){
		if (this->determine_type==FREE){
			ChildNode* current=this->children->start;
			while (current!=NULL){
				current->value->update();
				current=current->next;
			}
			return false;
		}
		else if (this->determine_type==START_END){
			this->X1=((Point*)this->parent[0])->X;
			this->Y1=((Point*)this->parent[0])->Y;
			this->X2=((Point*)this->parent[1])->X;
			this->Y2=((Point*)this->parent[1])->Y;
		}
		ChildNode* current=this->children->start;
		while (current!=NULL){
			current->value->update();
			current=current->next;
		}
		return true;
	}
	double Line::length(){
		return sqrt((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2));
	}
	Line* Line::LineXY(Point* P1,Point* P2,lin_type line_type){
		Sketch* sketch;
		if (P1->sketch!=P2->sketch) return NULL;
		else sketch=P1->sketch;
		Line* A=new Line();
		A->parent[0]=P1;
		A->parent[1]=P2;
		A->determine_type=START_END;
		A->line_type=line_type;
		P1->children->add(A);
		P2->children->add(A);
		A->update();
		return A;
	}
	double Line::getX1(){
		return this->X1;
	}
	double Line::getY1(){
		return this->Y1;
	}
	double Line::getX2(){
		return this->X2;
	}
	double Line::getY2(){
		return this->Y2;
	}
	Point* Line::getStart(){
		return (Point*)this->parent[0];
	}
	Point* Line::getEnd(){
		return (Point*)this->parent[1];
	}
	bool Line::setP1(double X1,double Y1){
		if(this->determine_type==FREE){
			this->X1=X1;
			this->Y1=Y1;
			this->update();
			return true;
		}
		else{
			return false;
		}
	}
	bool Line::setP2(double X2,double Y2){
		if(this->determine_type==FREE){
			this->X2=X2;
			this->Y2=Y2;
			this->update();
			return true;
		}
		else{
			return false;
		}
	}
	void Line::paint(){
		if (this->visible && !this->hasnon()){
			fprintf(_resultfile,"Line %f %f %f %f %d %s\n",this->X1,this->Y1,this->X2,this->Y2,this->line_type,this->name.c_str());
			printf("Line:(%f,%f)-(%f,%f),%s\n",this->X1,this->Y1,this->X2,this->Y2,this->name.c_str());
		}
	}
	int Line::getLineType(){
		if(this->line_type==SEGMENT)
			return 0;
		else if (this->line_type==RAY){
			return 1;
		}
		else {
			return 2;
		}
		return (int)this->line_type;
	}
	bool Line::hasnon(void){
		if (this->X1==NONEXIST||this->Y1==NONEXIST||this->X2==NONEXIST||this->Y2==NONEXIST){
			return true;
		}
		return false;
	}


	Circle::Circle():GeoObj(){
		this->X=NONEXIST;
		this->Y=NONEXIST;
		this->radius=NONEXIST;
		this->type=GCIRCLE;
	}
	Circle* Circle::DrawCircle(Point* center, Line* radius){
		if (center->sketch!=radius->sketch){
			return NULL;
		}
		Sketch* sketch=center->sketch;
		Circle* A=new Circle();
		A->determine_type=CENTER_RADIUS;
		A->parent[0]=center;
		A->parent[1]=radius;
		center->children->add(A);
		radius->children->add(A);
		A->update();
		return A;
	}
	Circle* Circle::DrawCircle(Point* center, double radius){
		Circle* A=new Circle();
		A->determine_type=CENTER;
		A->parent[0]=center;
		A->radius=radius;
		A->update();
		return A;
	}
	bool Circle::update(void){
		if (this->determine_type==FREE){
			ChildNode* current=this->children->start;
			while (current!=NULL){
				current->value->update();
				current=current->next;
			}
			return false;
		}else if(this->determine_type==CENTER){
			this->X=((Point*)this->parent[0])->X;
			this->Y=((Point*)this->parent[0])->Y;
		}else if(this->determine_type==CENTER_RADIUS){
			this->X=((Point*)this->parent[0])->X;
			this->Y=((Point*)this->parent[0])->Y;
			this->radius=((Line*)this->parent[1])->length();
		}
		ChildNode* current=this->children->start;
		while (current!=NULL){
			current->value->update();
			current=current->next;
		}
		return true;
	}
	Point* Circle::getCenter(){
		return (Point*)this->parent[0];
	}
	double Circle::getX(){
		return this->X;
	}
	double Circle::getY(){
		return this->Y;
	}
	double Circle::getRadius(){
		return this->radius;
	}
	bool Circle::setCenter(double X,double Y){
		if(this->determine_type==FREE){
			this->X=X;
			this->Y=Y;
			this->update();
			return true;
		}
		else{
			return false;
		}
	}
	bool Circle::setRadius(double r){
		if(this->determine_type==FREE||this->determine_type==CENTER){
			this->radius=r;
			this->update();
			return true;
		}
		return false;
	}
	void Circle::paint(){
		if (this->visible && !this->hasnon()){
			fprintf(_resultfile,"Circle %f %f %f %s\n",this->X,this->Y,this->radius,this->name.c_str());
			printf("Circle(%f,%f),%f,%s\n",this->X,this->Y,this->radius,this->name.c_str());
		}
	}
	bool Circle::hasnon(void){
		if (this->X==NONEXIST||this->Y==NONEXIST||this->radius==NONEXIST){
			return true;
		}
		return false;
	}

double* GeoObj::intercept(GeoObj* obj1,GeoObj* obj2){//determine the intercept position of two geo-objects
	if ((obj1->type!=GCIRCLE&&obj1->type!=GLINE)||(obj1->type!=GCIRCLE&&obj1->type!=GLINE)){//not right type;
		return NULL;
	}
	if (obj1->type==GLINE&&obj2->type==GLINE){//both are lines;
		if (obj1->hasnon()||obj2->hasnon()){
			double* result=new double[2];
			result[0]=result[1]=NONEXIST;
			return  result;
		}
		Line* line1=(Line*)obj1;
		Line* line2=(Line*)obj2;
		line1->length();
		if (line1->length()<0.001*0.001){//the two points are too near, refuse to calculate intercept
			double* result=new double[2];
			result[0]=result[1]=NONEXIST;
			return  result;
		}
		else{
			double* result=new double[2];
			//calculate parameters in Ax+By+c=0 for line1 and line2
			double X1=line1->X1;
			double Y1=line1->Y1;
			double X2=line1->X2;
			double Y2=line1->Y2;
			double X3=line2->X1;
			double Y3=line2->Y1;
			double X4=line2->X2;
			double Y4=line2->Y2;
			double a1=Y1-Y2,b1=X2-X1,c1=X1*Y2-X2*Y1;
			double a2=Y3-Y4,b2=X4-X3,c2=X3*Y4-X4*Y3;
			if (abs(a1*b2-b1*a2)<0.001){//parallel
				result[0]=result[1]=NONEXIST;
				return result;
			}
			else{
				double X=(b2*c1-b1*c2)/(a2*b1-a1*b2);
				double Y=(a1*c2-a2*c1)/(a2*b1-a1*b2);
				bool is_in_line1=false;
				bool is_in_line2=false;
				if (line1->line_type==LINE || (line1->line_type==RAY && (X-X1)*(X2-X1)>=0 && (Y-Y1)*(Y2-Y1)>=0) || ((X-X1)*(X-X2)<=0 && (Y-Y1)*(Y-Y2)<=0)){
					is_in_line1=true;
				}
				if (line2->line_type==LINE || (line2->line_type==RAY && (X-X3)*(X4-X3)>=0 && (Y-Y3)*(Y4-Y3)>=0) || ((X-X3)*(X-X4)<=0 && (Y-Y3)*(Y-Y4)<=0)){
					is_in_line2=true;
				}
				if (is_in_line1 && is_in_line2){
					result[0]=X;
					result[1]=Y;
					return result;
				}
				else{
					result[0]=result[1]=NONEXIST;
					return result;
				}
			}
		}
	}
	else if(obj1->type==GLINE||obj2->type==GLINE){//one of them is line, the other is circle.
		if (obj1->hasnon()||obj2->hasnon()){
			double* result=new double[4];
			result[0]=result[1]=result[2]=result[3]=NONEXIST;
			return  result;
		}
		double* result=new double[4];
		Line* line=(Line*)(obj1->type==GLINE?obj1:obj2);
		Circle* circle=(Circle*)(obj1->type==GLINE?obj2:obj1);
		double X1=line->X1,X2=line->X2,Y1=line->Y1,Y2=line->Y2;
		double X3=circle->X,Y3=circle->Y,r=circle->radius;
		double a1=Y1-Y2,b1=X2-X1,c1=X1*Y2-X2*Y1;
		if (abs(a1*X3+b1*Y3+c1)/sqrt(a1*a1+b1*b1)<=r+0.001){
            double Xnear=-(c1 + (b1*(a1*sqrt(a1*a1*r*r - a1*a1*X3*X3 - 2*a1*b1*X3*Y3 - 2*a1*c1*X3 + b1*b1*r*r - b1*b1*Y3*Y3 - 2*b1*c1*Y3 - c1*c1)+ a1*a1*Y3 - b1*c1 - a1*b1*X3))/(a1*a1 + b1*b1))/a1;
            double Xaway=-(c1 - (b1*(a1*sqrt(a1*a1*r*r - a1*a1*X3*X3 - 2*a1*b1*X3*Y3 - 2*a1*c1*X3 + b1*b1*r*r - b1*b1*Y3*Y3 - 2*b1*c1*Y3 - c1*c1)- a1*a1*Y3 + b1*c1 + a1*b1*X3))/(a1*a1 + b1*b1))/a1;
            double Ynear= (a1*sqrt(a1*a1*r*r - a1*a1*X3*X3 - 2*a1*b1*X3*Y3 - 2*a1*c1*X3 + b1*b1*r*r - b1*b1*Y3*Y3 - 2*b1*c1*Y3 - c1*c1) + a1*a1*Y3 - b1*c1 - a1*b1*X3)/(a1*a1 + b1*b1);
            double Yaway=-(a1*sqrt(a1*a1*r*r - a1*a1*X3*X3 - 2*a1*b1*X3*Y3 - 2*a1*c1*X3 + b1*b1*r*r - b1*b1*Y3*Y3 - 2*b1*c1*Y3 - c1*c1) - a1*a1*Y3 + b1*c1 + a1*b1*X3)/(a1*a1 + b1*b1);
            result[0]=Xnear;
			result[1]=Ynear;
			result[2]=Xaway;
			result[3]=Yaway;
			
		}
        else{
				
			result[0]=result[1]=result[2]=result[3]=NONEXIST;				
		}
		return result;
	}
	else{//two circles
		if (obj1->hasnon()||obj2->hasnon()){
			double* result=new double[4];
			result[0]=result[1]=result[2]=result[3]=NONEXIST;
			return  result;
		}
		double* result=new double[4];
		Circle* circle1=(Circle*)obj1;
		Circle* circle2=(Circle*)obj2;
		double x1=circle1->X,y1=circle1->Y,x2=circle2->X,y2=circle2->Y;
		double r1=circle1->radius,r2=circle2->radius;
		if ((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)>(r1+r2)*(r1+r2)||(x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)<(r1-r2)*(r1-r2)){
			result[0]=result[1]=result[2]=result[3]=NONEXIST;
               return result;
		}
		else{
			double Xnear,Ynear,Xaway,Yaway;
			if (abs(x1-x2)>0.1){
			Xnear=-(r1*r1 - r2*r2 - x1*x1 + x2*x2 - y1*y1 + y2*y2 + (y1*(x2*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - x1*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - r1*r1*y1 + r1*r1*y2 + r2*r2*y1 - r2*r2*y2 + x1*x1*y1 + x1*x1*y2 + x2*x2*y1 + x2*x2*y2 - y1*y2*y2 - y1*y1*y2 + y1*y1*y1 + y2*y2*y2 - 2.*x1*x2*y1 - 2.*x1*x2*y2))/(x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2) - (y2*(x2*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - x1*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 -  2.*y1*y2 + y2*y2)*(r1*r1 +  2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 +  2.*y1*y2 - y2*y2)) - r1*r1*y1 + r1*r1*y2 + r2*r2*y1 - r2*r2*y2 + x1*x1*y1 + x1*x1*y2 + x2*x2*y1 + x2*x2*y2 - y1*y2*y2 - y1*y1*y2 + y1*y1*y1 + y2*y2*y2 -  2.*x1*x2*y1 -  2.*x1*x2*y2))/(x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 -  2.*y1*y2 + y2*y2))/( 2.*x1 -  2.*x2);
            Xaway=-(r1*r1 - r2*r2 - x1*x1 + x2*x2 - y1*y1 + y2*y2 + (y1*(x1*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - x2*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2))- r1*r1*y1 + r1*r1*y2 + r2*r2*y1 - r2*r2*y2 + x1*x1*y1 + x1*x1*y2 + x2*x2*y1 + x2*x2*y2 - y1*y2*y2 - y1*y1*y2 + y1*y1*y1 + y2*y2*y2 - 2.*x1*x2*y1 - 2.*x1*x2*y2))/(x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2) - (y2*(x1*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - x2*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 -  2.*y1*y2 + y2*y2)*(r1*r1 +  2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 +  2.*y1*y2 - y2*y2)) - r1*r1*y1 + r1*r1*y2 + r2*r2*y1 - r2*r2*y2 + x1*x1*y1 + x1*x1*y2 + x2*x2*y1 + x2*x2*y2 - y1*y2*y2 - y1*y1*y2 + y1*y1*y1 + y2*y2*y2 -  2.*x1*x2*y1 -  2.*x1*x2*y2))/(x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 -  2.*y1*y2 + y2*y2))/( 2.*x1 -  2.*x2);
            Ynear=(x2*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - x1*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - r1*r1*y1 + r1*r1*y2 + r2*r2*y1 - r2*r2*y2 + x1*x1*y1 + x1*x1*y2 + x2*x2*y1 + x2*x2*y2 - y1*y2*y2 - y1*y1*y2 + y1*y1*y1 + y2*y2*y2 - 2.*x1*x2*y1 - 2.*x1*x2*y2)/(2*(x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2));
            Yaway=(x1*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - x2*sqrt((- r1*r1 + 2.*r1*r2 - r2*r2 + x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2)*(r1*r1 + 2.*r1*r2 + r2*r2 - x1*x1 + 2.*x1*x2 - x2*x2 - y1*y1 + 2.*y1*y2 - y2*y2)) - r1*r1*y1 + r1*r1*y2 + r2*r2*y1 - r2*r2*y2 + x1*x1*y1 + x1*x1*y2 + x2*x2*y1 + x2*x2*y2 - y1*y2*y2 - y1*y1*y2 + y1*y1*y1 + y2*y2*y2 - 2.*x1*x2*y1 - 2.*x1*x2*y2)/(2*(x1*x1 - 2.*x1*x2 + x2*x2 + y1*y1 - 2.*y1*y2 + y2*y2));
			}
			else{
				double x0=x1;
				
				Xnear=(2*x0*y1 - 2*x0*y2 + sqrt(-(r1 + r2 + y1 - y2)*(r1 + r2 - y1 + y2)*(r1 - r2 + y1 - y2)*(r1 - r2 - y1 + y2)))/(2*(y1 - y2));
				Xaway=-(2*x0*y2 - 2*x0*y1 + sqrt(-(r1 + r2 + y1 - y2)*(r1 + r2 - y1 + y2)*(r1 - r2 + y1 - y2)*(r1 - r2 - y1 + y2)))/(2*(y1 - y2));
				Ynear=-(r1*r1 - r2*r2 - y1*y1 + y2*y2)/(2*(y1 - y2));
				Yaway=Ynear;
			}
			result[0]=Xnear;
			result[1]=Ynear;
			result[2]=Xaway;
			result[3]=Yaway;
			return result;
			
		}
		
	}
}
void Sketch::paint(){
	Node* current=eleList->start;
	while (current!=NULL){
		current->value->paint();
		current=current->next;
	}
}
//**********************************************************



	variable::variable(){
		this->next=NULL;
	}




	bool Symbol_Table_Node::operator!=(const Symbol_Table_Node &orig)const{
		return !(this == &orig);
	}
	Symbol_Table_Node::Symbol_Table_Node(Symbol_Table_Node* parent){
		this->First=this->Last=NULL;
		this->Firstf=this->Lastf=0;
		this->parent=parent;
	}
	Symbol_Table_Node::~Symbol_Table_Node(){			
		for (variable* current=this->First;current!=NULL;current=current->next){
			switch (current->var_type){
			case var_float:
				delete current->var_strorage.val_float;
				break;
			case var_num:
				delete current->var_strorage.val_int;
				break;
			case var_string:
				delete current->var_strorage.val_string;
				break;
			case var_bool:
				delete current->var_strorage.val_bool;
				break;
			default:
				;
			}
		}
	}
	Symbol_Table_Node* Symbol_Table_Node::add_node(){
		Symbol_Table_Node* new_node=new Symbol_Table_Node(this);
		return new_node;
	}
	variable* Symbol_Table_Node::add_var(int value,string name){
		int* a=new int(value);
		variable* new_var=new variable;
		new_var->var_type=var_num;
		new_var->var_strorage.val_int=a;
		new_var->name=name;
		if (this->Last==NULL){
			this->First=this->Last=new_var;
			return new_var;
		}
		this->Last->next=new_var;
		this->Last=new_var;		
		return new_var;
	}
	variable* Symbol_Table_Node::add_var(string value,string name){
		string* a=new string(value);
		variable* new_var=new variable;
		new_var->var_type=var_string;
		new_var->var_strorage.val_string=a;
		new_var->name=name;
		if (this->Last==NULL){
			this->First=this->Last=new_var;
			return new_var;
		}
		this->Last->next=new_var;
		this->Last=new_var;
		
		return new_var;
	}
	variable* Symbol_Table_Node::add_var(double value,string name){
		variable* new_var=new variable;
		double* a=new double(value);
		new_var->var_type=var_float;
		new_var->var_strorage.val_float=a;
		new_var->name=name;
		if (this->Last==NULL){
			this->First=this->Last=new_var;
			return new_var;
		}
		this->Last->next=new_var;
		this->Last=new_var;		
		return new_var;
	}
	variable* Symbol_Table_Node::add_var(bool value,string name){
		bool* a=new bool(value);
		variable* new_var=new variable;
		new_var->var_type=var_bool;
		new_var->var_strorage.val_bool=a;
		new_var->name=name;
		if (this->Last==NULL){
			this->First=this->Last=new_var;
			return new_var;
		}
		this->Last->next=new_var;
		this->Last=new_var;
		return new_var;
	}
	variable* Symbol_Table_Node::add_var(Point* value,string name){
		variable* new_var=new variable;
		new_var->var_type=var_point;
		new_var->var_strorage.val_point=value;
		new_var->name=name;
		if (this->Last==NULL){
			this->First=this->Last=new_var;
			return new_var;
		}
		this->Last->next=new_var;
		this->Last=new_var;
		return new_var;
	}
	variable* Symbol_Table_Node::add_var(Circle* value,string name){
		variable* new_var=new variable;
		new_var->var_type=var_circle;
		new_var->var_strorage.val_circle=value;
		new_var->name=name;
		if (this->Last==NULL){
			this->First=this->Last=new_var;
			return new_var;
		}
		this->Last->next=new_var;
		this->Last=new_var;
		
		return new_var;
	}
	variable* Symbol_Table_Node::add_var(Line* value,string name){
		variable* new_var=new variable;
		new_var->var_type=var_line;
		new_var->var_strorage.val_line=value;
		new_var->name=name;
		if (this->Last==NULL){
			this->First=this->Last=new_var;
			return new_var;
		}
		this->Last->next=new_var;
		this->Last=new_var;
		
		return new_var;
	}
	void Symbol_Table_Node::add_function(func_pointer funcp,string name){
		function* new_func= new function;
		new_func->funcp=funcp;
		new_func->name=name;
		if (this->Lastf==NULL){
			this->Firstf=this->Lastf=new_func;
			return;
		}
		this->Lastf->next=new_func;
		this->Lastf=new_func;
	}
	void* Symbol_Table_Node::get_var(string name,bool is_local){
		variable* current=this->First;
		while (current!=NULL){
			if (current->name==name){
				switch (current->var_type){
				case var_float:
					return current->var_strorage.val_float;
				case var_num:
					return current->var_strorage.val_int;
				case var_string:
					return current->var_strorage.val_string;
				case var_bool:
					return current->var_strorage.val_bool;
				case var_point:
					return &(current->var_strorage.val_point);
				case var_circle:
					return &(current->var_strorage.val_circle);
				case var_line:
					return &(current->var_strorage.val_line);
				default:
					;
				}	
			}else{
				current=current->next;
			}
			
		}
		if (is_local){
			return NULL;
			}
			else if (this->parent==NULL){
				return NULL;
			}
			else{
				return this->parent->get_var(name,is_local);
			}
	}
	func_pointer Symbol_Table_Node::get_function(string name,bool is_local){
		function* current=this->Firstf;
		while (current!=NULL){
			if (current->name==name){
				return current->funcp;
			}else{
				current=current->next;
			}
		}
		if (is_local){
			return NULL;
			}
			else if (this->parent==NULL){
				return NULL;
			}
			else{
				return this->parent->get_function(name,is_local);
			}
	}





	int lib::print(string a){
		cout<<a;
		return 0;
	}
	double lib::sin(double x){
		return sqrt(x);		
	}
	Line* lib::LineST(Point* P1,Point* P2,int line_type){
		//lin_type line_type=SEGMENT
		return Line::LineXY(P1,P2,(lin_type) line_type);
	}
	Circle* lib::DrawCircle(Point* center, Line* radius){
		return Circle::DrawCircle(center,radius);
	}
	Circle* lib::DrawCircle(Point* center, double radius){
		return Circle::DrawCircle(center,radius);
	}
	Point* lib::intersect(GeoObj* GeoObj1,GeoObj* GeoObj2,bool isnear){
		Point* a=Point::intersect(GeoObj1,GeoObj2,isnear);
		return a;
	}
	Point* lib::PointXY(double X,double Y){
		Point* a= new Point;
		a->setXY(X,Y);
		return a;
	}
	Line* lib::LineXY(double X1,double Y1,double X2,double Y2,int line_type){
		Point* o1=this->PointXY(X1,Y1);
		Point* o2=this->PointXY(X2,Y2);
		Line* a=this->LineST(o1,o2,(lin_type) line_type);
		return a;
	}
	Circle* lib::CircleXYr(double X,double Y,double r){
		Point* o=this->PointXY(X,Y);
		Circle* a=this->DrawCircle(o,r);
		a->setCenter(X,Y);
		a->setRadius(r);
		return a;
	}
	void lib::paint(){
		fprintf(_resultfile,"START\n");
		_sketch->paint();
		fprintf(_resultfile,"END\n");
	}